#include <iostream>
#include <assert.h>
#include <direct.h>
#include "../../core/utilities/FlushToMem.h"
#include "../../core/getandset/ConvertDataType.h"
#include "../../XTensor.h"
#include "../../XGlobal.h"
#include "umHalf.h"

using namespace nts;

int main(int argc, char* argv[])
{
	char *path;
	path = getcwd(NULL, 0);
	strcat(path, "\\source\\tensor\\halfLib\\HalfFloat\\dump");

	XTensor a;
	XTensor halfa;
	int dim = 4;
	int devId = 0;
	InitTensor2DV2(&a, dim, dim, X_FLOAT, devId);
	a.SetDataRand(-2.0, 2.0);

	halfa = ConvertDataType(a, X_FLOAT16);
	printf("============save model================\n");

	halfa.Dump(&halfa, stderr, "halfa:");
	GPUToCPUFlush(&halfa);
	
	FILE * file = fopen(path, "wb");
	halfa.Dump(file, "halfa:");
	//a.Dump(file, "a");
	fclose(file);

	XTensor halfb;
	InitTensor2DV2(&halfb, dim, dim, X_FLOAT16, devId);

	XTensor b;
	InitTensor2DV2(&b, dim, dim, X_FLOAT, devId);
	printf("==============read model=============\n");
	FILE *read = fopen(path, "rb");
	halfb.Read(read, "halfa:");
	//b.Read(read, "a");
	fclose(read);

	halfb.Dump(&halfb, stderr, "halfb:");

	return 0;
}