#include <stdio.h>
#include <direct.h>
#include "../../core/CHeader.h"
#include "../../core/utilities/FlushToMem.h"
#include "../../core/getandset/ConvertDataType.h"
#include "../../XTensor.h"
#include "../../XGlobal.h"

using namespace nts;

int main(int argc, const char ** argv) {
	char *path;
	path = getcwd(NULL, 0);
	strcat(path, "\\source\\tensor\\halfLib\\half\\dump");

	int dim = 4;
	int devId = 0;

	XTensor a;
	XTensor b;
	XTensor c;

	XTensor halfa;
	XTensor halfb;
	XTensor halfc;

	InitTensor2DV2(&a, dim, dim, X_FLOAT, devId);
	InitTensor2DV2(&c, dim, dim, X_FLOAT, devId);
	InitTensor2DV2(&halfb, dim, dim, X_FLOAT16, devId);

	a.SetDataRand(-2.0, 2.0);
	c.SetDataRand(-2.0, 2.0);
	halfa = ConvertDataType(a, X_FLOAT16);
	halfc = ConvertDataType(c, X_FLOAT16);

	printf("============save model================\n");
	halfa.Dump(&halfa, stderr, "halfa:");
	GPUToCPUFlush(&halfa);

	FILE * file = fopen(path, "wb");
	halfa.Dump(file, "halfa:");
	//a.Dump(file, "a");
	fclose(file);

	printf("==============read model=============\n");
	FILE *read = fopen(path, "rb");
	halfb.Read(read, "halfa:");
	//b.Read(read, "a");
	fclose(read);
	halfb.Dump(&halfb, stderr, "halfb:");
	printf("==============BMMUL=============\n");
	b = BMMul(a, X_NOTRANS, c, X_NOTRANS);
	b.Dump(stderr,"b:");
	printf("==============BMMUL-float=============\n");
	halfa= BMMul(halfb, X_NOTRANS, halfc, X_NOTRANS);
	halfa.Dump(&halfa, stderr, "halfla:");
	
	return 0;
}